config/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path
from django.views import defaults as default_views
from django.views.generic import TemplateView
from drf_spectacular.views import SpectacularAPIView, SpectacularSwaggerView
from rest_framework.authtoken.views import obtain_auth_token

urlpatterns = [
    path("", TemplateView.as_view(template_name="pages/home.html"), name="home"),
    path(
        "about/", TemplateView.as_view(template_name="pages/about.html"), name="about"
    ),
    # Django Admin, use {% url 'admin:index' %}
    path(settings.ADMIN_URL, admin.site.urls),
    # Languages selections
    path("i18n/", include("django.conf.urls.i18n")),
    # Audit log and activity stream
    path("activity/", include("actstream.urls")),
    # User management
    path("users/", include("diesos.users.urls", namespace="users")),
    path("accounts/", include("allauth.urls")),
    # Diesos Apps
    path("artefacts/", include("diesos.artefacts.urls", namespace="artefacts")),
    path("locations/", include("diesos.locations.urls", namespace="locations")),
    path("scan/", include("diesos.barcodes.urls", namespace="barcodes")),
    path("treatments/", include("diesos.treatments.urls", namespace="treatments")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

# API URLS
urlpatterns += [
    # API base url
    path("api/", include("config.api_router")),
    # DRF auth token
    path("auth-token/", obtain_auth_token),
    path("api/schema/", SpectacularAPIView.as_view(), name="api-schema"),
    path(
        "api/docs/",
        SpectacularSwaggerView.as_view(url_name="api-schema"),
        name="api-docs",
    ),
]

if settings.DEBUG:
    # This allows the error pages to be debugged during development, just visit
    # these url in browser to see how these error pages look like.
    urlpatterns += [
        path(
            "400/",
            default_views.bad_request,
            kwargs={"exception": Exception("Bad Request!")},
        ),
        path(
            "403/",
            default_views.permission_denied,
            kwargs={"exception": Exception("Permission Denied")},
        ),
        path(
            "404/",
            default_views.page_not_found,
            kwargs={"exception": Exception("Page not Found")},
        ),
        path("500/", default_views.server_error),
    ]
    if "debug_toolbar" in settings.INSTALLED_APPS:
        import debug_toolbar

        urlpatterns = [path("__debug__/", include(debug_toolbar.urls))] + urlpatterns

diesos/artefacts/urls.py
from django.urls import path

from diesos.artefacts import views

app_name = "artefacts"

urlpatterns = [
    path("", views.ArtefactListView.as_view(), name="list"),
    path("add", views.ArtefactCreateView.as_view(), name="add"),
    path("<int:pk>/change", views.ArtefactUpdateView.as_view(), name="change"),
    path("<int:pk>/delete", views.ArtefactDeleteView.as_view(), name="delete"),
    path("<int:pk>", views.ArtefactDetailView.as_view(), name="view"),
    path("<int:pk>/scan", views.ArtefactScanView.as_view(), name="scan"),
    path(
        "<int:pk>/scan/finish",
        views.finish_stabilization_measures,
        name="finish-stabilization",
    ),
    path(
        "<int:pk>/scan/start/<int:processing_line_id>",
        views.start_stabilization_measures,
        name="start-stabilization",
    ),
    path("type", views.ArtefactTypeListView.as_view(), name="list-type"),
    path("type/add", views.ArtefactTypeCreateView.as_view(), name="add-type"),
    path(
        "type/<int:pk>/change",
        views.ArtefactTypeUpdateView.as_view(),
        name="change-type",
    ),
    path(
        "type/<int:pk>/delete",
        views.ArtefactTypeDeleteView.as_view(),
        name="delete-type",
    ),
    path(
        "type/<int:pk>/undelete",
        views.undelete_artefact_type,
        name="undelete-type",
    ),
    path("type/save-type-ordering", views.save_new_ordering, name="save-type-ordering"),
    path(
        "<int:pk>/take-picture",
        views.ArtefactTakePicture.as_view(),
        name="take-picture",
    ),
    path("damage/group", views.DamageGroupListView.as_view(), name="list-damage-group"),
    path(
        "damage/group/add",
        views.DamageGroupCreateView.as_view(),
        name="add-damage-group",
    ),
    path(
        "damage/group/<int:pk>/delete",
        views.DamageGroupDeleteView.as_view(),
        name="delete-damage-group",
    ),
    path(
        "damage/group/<int:pk>/undelete",
        views.undelete_damage_group,
        name="undelete-damage-group",
    ),
    path(
        "damage/group/<int:pk>/change",
        views.DamageGroupUpdateView.as_view(),
        name="change-damage-group",
    ),
    path("damage/type", views.TypeOfDamageListView.as_view(), name="list-damage-type"),
    path(
        "damage/type/add",
        views.TypeOfDamageCreateView.as_view(),
        name="add-damage-type",
    ),
    path(
        "damage/type/<int:pk>/delete",
        views.TypeOfDamageDeleteView.as_view(),
        name="delete-damage-type",
    ),
    path(
        "damage/type/<int:pk>/undelete",
        views.undelete_type_of_damage,
        name="undelete-damage-type",
    ),
    path(
        "damage/type/<int:pk>/change",
        views.TypeOfDamageUpdateView.as_view(),
        name="change-damage-type",
    ),
    path(
        "<int:pk>/damage-assessment",
        views.DamageAssessmentUpdateView.as_view(),
        name="change-damage",
    ),
    path("priority", views.PriorityLevelListView.as_view(), name="priority-level"),
    path(
        "priority/<int:pk>/change",
        views.PriorityLevelUpdateView.as_view(),
        name="change-priority",
    ),
    path(
        "<int:pk>/stabilization",
        views.StabilizationMeasureUpdateView.as_view(),
        name="change-stabilization-measure",
    ),
    path(
        "<int:pk>/stabilization/delete/<int:treatment_type_id>",
        views.delete_treatment_type,
        name="delete-treatment-type",
    ),
    path(
        "<int:pk>/stabilization/save-treatment-type-ordering",
        views.save_treatment_type_ordering,
        name="save-treatment-type-ordering",
    ),
    path(
        "existing-collection/import", views.UploadCsvView.as_view(), name="import-file"
    ),
    path(
        "existing-collection/headers/edit",
        views.FileHeaderEditView.as_view(),
        name="header-edit-existing-collection",
    ),
    path(
        "existing-collection/map",
        views.CsvMapperView.as_view(),
        name="map-existing-collection",
    ),
    path(
        "existing-collection/map/complex",
        views.ComplexMapperView.as_view(),
        name="map-complex-existing-collection",
    ),
    path(
        "existing-collection/<int:pk>",
        views.ExistingCollectionDetailView.as_view(),
        name="view-existing-collection",
    ),
    path(
        "existing-collection",
        views.ExistingCollectionListView.as_view(),
        name="list-existing-collection",
    ),
    path(
        "existing-collection/<int:pk>/delete",
        views.ExistingCollectionDeleteView.as_view(),
        name="delete-existing-collection",
    ),
    path(
        "existing-collection/add",
        views.create_existing_collection,
        name="add-existing-collection",
    ),
]

diesos/barcodes/urls.py
from django.urls import path

from diesos.barcodes.views import scan_barcode, search_barcode, set_scanner

app_name = "barcodes"
urlpatterns = [
    path("", view=scan_barcode, name="read"),
    path("search/", view=search_barcode, name="search"),
    path("set/<str:scanner>", view=set_scanner, name="set"),
]

diesos/locations/urls.py
from django.urls import path

from diesos.locations import views

app_name = "locations"

urlpatterns = [
    path("", views.LocationListView.as_view(), name="list"),
    path("add", views.LocationCreateView.as_view(), name="add"),
    path("<int:pk>", views.LocationDetailView.as_view(), name="view"),
    path("<int:pk>/change", views.LocationUpdateView.as_view(), name="change"),
    path("<int:pk>/delete", views.LocationDetailView.as_view(), name="delete"),
    path("<int:pk>/undelete", views.undelete_location, name="undelete-type"),
    path("types", views.LocationTypesListView.as_view(), name="list-types"),
    path("types/add", views.LocationTypeCreateView.as_view(), name="add-type"),
    path("types/<int:pk>", views.LocationTypeDetailView.as_view(), name="view-type"),
    path(
        "types/<int:pk>/change",
        views.LocationTypeUpdateView.as_view(),
        name="change-type",
    ),
    path(
        "types/<int:pk>/delete",
        views.LocationTypeDeleteView.as_view(),
        name="delete-type",
    ),
    path("types/<int:pk>/undelete", views.undelete_location_type, name="undelete-type"),
]

diesos/users/urls.py
from django.urls import path

from diesos.users.views import user_detail_view, user_redirect_view, user_update_view

app_name = "users"
urlpatterns = [
    path("~redirect/", view=user_redirect_view, name="redirect"),
    path("~update/", view=user_update_view, name="update"),
    path("<str:username>/", view=user_detail_view, name="detail"),
]

diesos/locations/models.py
from django.db import models
from django.urls import reverse
from django.utils.translation import gettext_lazy as _
from safedelete.models import SafeDeleteModel
from treebeard.mp_tree import MP_Node


class LocationType(SafeDeleteModel):
    name = models.CharField(verbose_name=_("name"), max_length=225)
    description = models.TextField(verbose_name=_("description"), null=True, blank=True)

    class Meta:
        verbose_name = _("location type")
        verbose_name_plural = _("location types")
        ordering = ["name"]

    def __str__(self):
        return f"{self.name}"

    def get_absolute_url(self):
        return reverse("locations:view-type", kwargs={"pk": self.pk})


class Location(MP_Node, SafeDeleteModel):
    name = models.CharField(
        verbose_name=_("location name"), max_length=225, unique=True
    )
    description = models.TextField(verbose_name=_("description"), null=True, blank=True)
    color = models.CharField(max_length=7, null=True, blank=True)

    location_type = models.ForeignKey(
        LocationType,
        verbose_name=_("location type"),
        related_name="locations",
        blank=True,
        null=True,
        on_delete=models.SET_NULL,
    )

    elevation = models.IntegerField(
        verbose_name=_("elevation"),
        null=True,
        blank=True,
    )
    latitude = models.DecimalField(
        verbose_name=_("latitude"),
        max_digits=9,
        decimal_places=6,
        null=True,
        blank=True,
    )
    longitude = models.DecimalField(
        verbose_name=_("longitude"),
        max_digits=9,
        decimal_places=6,
        null=True,
        blank=True,
    )

    node_order_by = ["name"]

    def __str__(self):
        return f"{self.name}"

    class Meta:
        verbose_name = _("location")
        verbose_name_plural = _("locations")
        ordering = ["name"]

    def get_absolute_url(self):
        return reverse("locations:view", kwargs={"pk": self.pk})

diesos/barcodes/views.py
from actstream import action
from django.contrib import messages
from django.contrib.auth.decorators import permission_required
from django.shortcuts import redirect, render
from django.urls import reverse
from django.utils.translation import gettext_lazy as _

from diesos.barcodes.barcode_resolver import resolve_barcode


def set_scanner(request, scanner):
    # We set the user's preference and redirect to the appropriate page
    if scanner == "reader":
        request.session["scanner"] = "reader"
    else:
        request.session["scanner"] = "mobile"

    if request.GET.get("parent_id") and request.GET.get("option"):
        url = (
            reverse("barcodes:read")
            + f'?parent_id={request.GET.get("parent_id")}&option={request.GET.get("option")}'
        )

        return redirect(url)

    return redirect("barcodes:read")


@permission_required("artefacts.view_artefact")
def scan_barcode(request):
    # We check if the user has already scanned a barcode
    scanner = request.session.get("scanner", False)
    if scanner:
        if scanner == "mobile":
            # We display the mobile scanner page
            return render(request, "barcodes/scanner.html")
        else:
            # We display the desktop scanner page
            return render(request, "barcodes/form.html")
    else:
        request.session["scanner"] = "mobile"
        return render(request, "barcodes/scanner.html")


@permission_required("artefacts.view_artefact")
def search_barcode(request):
    barcode = request.GET.get("barcode")
    parent_id = request.GET.get("parent_id")
    option = request.GET.get("option")
    if barcode:
        # Objects matching scan data
        objects = resolve_barcode(barcode)
        # Objects matching scan data excluding existing collection
        not_existing_collection_objects = [
            obj for obj in objects if obj["object_type"] != "existing_collection"
        ]
        if not objects:
            # This is a new barcode, we can create an object (or it is a scanning error)
            # TODO: add link to buttons as soon as the models are available
            return render(
                request,
                "barcodes/create.html",
                {"barcode": barcode, "parent_id": parent_id, "option": option},
            )
        elif len(objects) == 1 and objects[0]["object_type"] != "existing_collection":
            # This is a single artefact or shortID, we redirect to the object's url
            # TODO: add location (target) to the action
            if "object" in objects[0] and objects[0]["object_type"] == "artefact":
                object_id = objects[0]["object"].id
                return redirect("artefacts:scan", pk=object_id)
            else:
                if "object" in objects[0]:
                    action.send(
                        request.user,
                        verb=_("scanned"),
                        action_object=objects[0]["object"],
                        target=request.processing_line,
                    )
                return redirect(objects[0]["url"])

        elif len(objects) == 1 and objects[0]["object_type"] == "existing_collection":
            # We found only an existingCollection object, we want to create a new artefact from existing info
            messages.success(request, "Existing collection has been found !")
            return render(
                request,
                "barcodes/import.html",
                {"barcode": barcode, "existing_collection": objects[0]["data"]},
            )

        elif len(objects) == 2 and len(not_existing_collection_objects) == 1:
            # We found one object and its existing collection, the user is redirected to the object
            return redirect(not_existing_collection_objects[0]["url"])
        else:
            # We have more than one object, the user have to select the right one
            # We exclude existing_collection objects
            return render(
                request,
                "barcodes/results.html",
                {"barcode": barcode, "objects": not_existing_collection_objects},
            )
    else:
        # We display the form to input a barcode manually or with an external reader
        request.session["scanner"] = "reader"
        return render(request, "barcodes/form.html")

diesos/users/api/views.py
from django.contrib.auth import get_user_model
from rest_framework import status
from rest_framework.decorators import action
from rest_framework.mixins import ListModelMixin, RetrieveModelMixin, UpdateModelMixin
from rest_framework.response import Response
from rest_framework.viewsets import GenericViewSet

from .serializers import UserSerializer

User = get_user_model()


class UserViewSet(RetrieveModelMixin, ListModelMixin, UpdateModelMixin, GenericViewSet):
    serializer_class = UserSerializer
    queryset = User.objects.all()
    lookup_field = "username"

    def get_queryset(self, *args, **kwargs):
        assert isinstance(self.request.user.id, int)
        return self.queryset.filter(id=self.request.user.id)

    @action(detail=False)
    def me(self, request):
        serializer = UserSerializer(request.user, context={"request": request})
        return Response(status=status.HTTP_200_OK, data=serializer.data)

diesos/users/views.py
from django.contrib.auth import get_user_model
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.messages.views import SuccessMessageMixin
from django.urls import reverse
from django.utils.translation import gettext_lazy as _
from django.views.generic import DetailView, RedirectView, UpdateView

User = get_user_model()


class UserDetailView(LoginRequiredMixin, DetailView):
    model = User
    slug_field = "username"
    slug_url_kwarg = "username"


user_detail_view = UserDetailView.as_view()


class UserUpdateView(LoginRequiredMixin, SuccessMessageMixin, UpdateView):
    model = User
    fields = ["name"]
    success_message = _("Information successfully updated")

    def get_success_url(self):
        assert (
            self.request.user.is_authenticated
        )  # for mypy to know that the user is authenticated
        return self.request.user.get_absolute_url()

    def get_object(self):
        return self.request.user


user_update_view = UserUpdateView.as_view()


class UserRedirectView(LoginRequiredMixin, RedirectView):
    permanent = False

    def get_redirect_url(self):
        return reverse("users:detail", kwargs={"username": self.request.user.username})


user_redirect_view = UserRedirectView.as_view()

diesos/templates/locations/location_detail.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{{ object.name }}{% endblock %}

{% block content %}
  <div class="row mt-2">
    <div class="col">
      <h1>{% if object.color %}<span class="color-box" style="background-color:{{ object.color }}"></span> {% endif %}{{ object.name }}</h1>
      <p><i>{{ object.description }}</i></p>
    </div>
  </div>
  <div class="row">
    <div class="col text-end">
      <a href="{% url 'locations:change' object.id %}" class="btn btn-outline-primary"><i class="bi bi-pencil"></i></a>
    </div>
  </div>
  <div class="row">
    <div class="col-6">
      <p><i class="bi bi-geo-alt-fill"></i> {% translate 'located inside'|capfirst %}:
        {% if object.get_parent %}
          <a href="{{ object.get_parent.get_absolute_url }}">{{ object.get_parent }}</a>
        {% else %}
          {% translate 'none (root location)'|capfirst %}
        {% endif %}
      </p>
      <h2>{% translate 'inside locations'|capfirst %}</h2>
      {% include 'locations/snippets/location_table.html' with locations=object.get_descendants compact=True %}
    </div>
    <div class="col-6">
      {% if object.latitude and object.longitude %}
        <iframe width="425" height="350" frameborder="0" scrolling="no" marginheight="0" marginwidth="0"
                src="https://www.openstreetmap.org/export/embed.html?layer=mapnik&amp;marker={{ location.latitude|floatformat:"5u" }}%2C{{ location.longitude|floatformat:"5u" }}" style="border: 1px solid black"></iframe>
        <br/><small><i class="bi bi-map"></i> <a href="geo:46.99874,6.94125?z=19">{% translate "Open a larger map" %}</a></small>
      {% endif %}
    </div>
  </div>
  <div class="row">
    <div class="col">
      <h2>{% translate 'processing lines'|capfirst %}</h2>
      {% include 'treatments/snippets/processingline_table.html' with processing_lines=object.processing_lines.all compact=True %}
    </div>
  </div>
  <div class="row">
    <div class="col">
      <h2>{% translate 'artefacts'|capfirst %}</h2>
      <p>Include the list of artefacts currently at this location...</p>
    </div>
  </div>
{% endblock %}

diesos/templates/locations/location_form.html
{% extends "base.html" %}
{% load crispy_forms_tags %}

{% block content %}
  <h1>Create / Edit location</h1>

  <div class="row">
    <div class="col">
        <form method="post">
            {% csrf_token %}
            {{form|crispy}}
            <div class="d-flex justify-content-start mt-5">
              <a href="{% url 'locations:list' %}" class="btn btn-outline-secondary me-2"><i class="bi-x-lg"></i> Cancel</a>
              <button type="submit" class="btn btn-primary">Save</button>
            </div>
        </form>
    </div>
  </div>

{% endblock %}

diesos/templates/locations/location_list.html
{% extends "base.html" %}
{% load i18n %}
{% block title %}{% translate "locations"|capfirst %}{% endblock %}
{% block content %}
  <div class="row mt-2">
    <div class="col-12">
      <h1>{% translate "locations"|capfirst %}</h1>
    </div>
  </div>
  <div class="row">
    <div class="col text-end">
      {% if perms.locations.add_location %}
        <a href="{% url 'locations:add' %}" class="btn btn-outline-primary ">{% translate "add"|capfirst %}</a>
      {%  endif %}
    </div>
  </div>
  <div class="row">
    <div class="col">
      {% include 'locations/snippets/location_table.html' with locations=object_list %}
    </div>
  </div>
{% endblock %}

diesos/templates/locations/locationtype_confirm_delete.html
{% extends "base.html" %}
{% load i18n %}
{% block title %}{% translate "delete location type"|capfirst %}{% endblock %}
{% block content %}
  <div class="row">
    <div class="col">
      <h1>{% translate "delete location type"|capfirst %}</h1>
    </div>
  </div>
  <div class="row">
    <div class="col">
        <form method="post">
            {% csrf_token %}
            <div class="alert alert-warning" role="alert">
                {% blocktranslate %}
                  Confirm that you want to delete the location type <strong>{{ object }}</strong>
                {% endblocktranslate %}
            </div>
            <div class="d-flex justify-content-start mt-5">
              <a href="{% url 'locations:list-types' %}" class="btn btn-outline-secondary me-2"><i class="bi-x-lg"></i> {% translate "cancel"|capfirst %}</a>
              <button type="submit" class="btn btn-danger">{% translate "delete"|capfirst %}</button>
            </div>
        </form>
    </div>
</div>
{% endblock %}

diesos/templates/locations/locationtype_detail.html
{% extends "base.html" %}
{% load i18n %}
{% block title %}{{ object.name }}{% endblock %}
{% block content %}
  <div class="row mt-2">
    <div class="col-12">
      <h1>
        {{ object.name }}
      </h1>
    </div>
  </div>
  <div class="row">
    <div class="col">
      {% include 'locations/snippets/location_table.html' with locations=object.locations.all %}
    </div>
  </div>
{% endblock %}

diesos/templates/locations/locationtype_form.html
{% extends "base.html" %}
{% load i18n %}
{% load crispy_forms_tags %}

{% block title %}{% translate "location type"|capfirst %}{% endblock %}

{% block content %}
  <div class="row">
    <div class="col">
        <h1>{% translate "location type"|capfirst %}</h1>
    </div>
  </div>
  <div class="row">
    <div class="col">
        <form method="post">
            {% csrf_token %}
            {{form|crispy}}
            <div class="d-flex justify-content-start mt-5">
              <a href="{% url 'locations:list-types' %}" class="btn btn-outline-secondary me-2"><i class="bi-x-lg"></i> {% translate "cancel"|capfirst %}</a>
              <button type="submit" class="btn btn-primary">{% translate "save"|capfirst %}</button>
            </div>
        </form>
    </div>
  </div>
</div>
{% endblock %}

diesos/templates/locations/locationtype_list.html
{% extends "base.html" %}
{% load i18n %}
{% block title %}{% translate "location types"|capfirst %}{% endblock %}
{% block content %}
  <div class="row mt-2">
    <div class="col-12">
      <h1>{% translate "location types"|capfirst %}</h1>
    </div>
  </div>
  <div class="row">
    <div class="col text-end">
      {% if perms.locations.add_locationtype %}
        <a href="{% url 'locations:add-type' %}" class="btn btn-outline-primary ">{% translate "add"|capfirst %}</a>
      {%  endif %}
    </div>
  </div>
  <div class="row">
    <div class="col">
      <table class="table table-hover">
        <thead>
          <tr>
            <th>{% translate 'name'|capfirst %}</th>
            <th>{% translate 'description'|capfirst %}</th>
            <th></th>
          </tr>
        </thead>
        <tbody>
          {% for type in object_list %}
          <tr onclick="window.location='{{ type.get_absolute_url }}'">
            <td>{{ type.name }}</td>
            <td>{{ type.description }}</td>
            <td>
              <div class="d-flex justify-content-end">
                {% if perms.locations.change_locationtype %}
                  <a href="{% url 'locations:change-type' type.id %}" class="btn-sm btn-outline-primary mx-1"><i class="bi bi-pencil"></i></a>
                {%  endif %}
                {% if perms.locations.delete_locationtype %}
                  <a href="{% url 'locations:delete-type' type.id %}" class="btn-sm btn-outline-danger mx-1"><i class="bi bi-trash"></i></a>
                {%  endif %}
              </div>
            </td>

          </tr>
          {% empty %}
          <tr>
            <td colspan="3">{% translate "there are currently no location types"|capfirst %}</td>
          </tr>
          {% endfor %}
        </tbody>
      </table>
    </div>
  </div>
{% endblock %}